package org.mandarax.xkb.framework;

/**
 *  Copyright (C) 1999-2004  Jens Dietrich (mailto:mandarax@jbdietrich.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.lang.reflect.Method;
import java.util.List;
import java.util.Map;

import org.jdom.Element;
import org.mandarax.kernel.LogicFactory;
import org.mandarax.xkb.XKBException;

/**
 * An adapter class for methods.
 * @see java.lang.reflect.Method
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.6 
 */
public class XMLAdapter4Methods extends AbstractXMLAdapter {
      public static final String METHOD = "method";
      public static final String NAME = "name";
      public static final String DECLARING_TYPE = "declaring_type";
      public static final String PARAMETER_TYPES = "parameter_types";

/**
 * Export an object, i.e., convert it to an element in the DOM.
 * @param obj an object
 * @param driver the generic driver
 * @param cache a cache used in order to associate the same
 * id with various occurences of the same object
 * @exception an XKBException is thrown if export fails
 */
public Element exportObject(Object obj,GenericDriver driver,Map cache) throws  XKBException {
      check(obj,Method.class);
      Method m = (Method)obj;
      Element e = new Element(METHOD);

      // add name
      e.setAttribute(NAME,m.getName());

      // add declaring type
      Element edt = new Element(DECLARING_TYPE);
      e.addContent(edt);
      Element e2 = exportObject(m.getDeclaringClass(),GenericDriver.TYPE,driver,cache);
      edt.addContent(e2);

      // add parameter types
      Element ets = new Element(PARAMETER_TYPES);
      e.addContent(ets);
      exportChildren(m.getParameterTypes(),ets,GenericDriver.TYPE,driver,cache);

      return e;
}
/**
 * Build an object from an XML element.
 * @param e an element
 * @param driver the generic driver
 * @param cache a cache used to identify objects that have the same id
 * @param lfactory the logic factory used to create objects
 * @exception an XKBException is thrown if import fails
 */
public Object importObject(Element e,GenericDriver driver,Map cache,LogicFactory lfactory) throws XKBException {
       // get name
       String methodName = e.getAttributeValue(NAME);
       // get declaring type
       Element eDecl = e.getChild(DECLARING_TYPE);
       Element eType = (Element)eDecl.getChildren().get(0);
       XMLAdapter adapter = driver.getAdapterByTagName(eType.getName());
       Class declType = (Class)adapter.importObject(eType,driver,cache,lfactory);
       // get parameter types
       Element eParam = e.getChild(PARAMETER_TYPES);
       List eTypes = eParam.getChildren();
       Class[] parTypes = new Class[eTypes.size()];
       for (int i=0;i<eTypes.size();i++) {
            eType = (Element)eTypes.get(i);
            parTypes[i] = (Class)adapter.importObject(eType,driver,cache,lfactory);
       }
       // build method
       try {
            return declType.getMethod(methodName,parTypes);
       }
       catch (Exception x) {
            StringBuffer msg = new StringBuffer();
            msg.append("Cannot find method ");
            msg.append(methodName);
            msg.append('(');
            for (int i=0;i<parTypes.length;i++) {
                  if (i>0) msg.append(',');
                  msg.append(parTypes[i].toString());
            }
            msg.append(") in class ");
            msg.append(declType);

            throw new XKBException(msg.toString());
       }
}
/**
 * Get the name of the associated tag (element).
 * @return a string
 */
public String getTagName() {
      return METHOD;
}
/**
 * Get the kind of object the adapter can export/import.
 * @return a string
 */
public String getKindOfObject() {
      return GenericDriver.METHOD;
}
}
